//+------------------------------------------------------------------+
//|                                                    TrendLabs.mq4 |
//|                               Copyright  2008, NonDisclosure007 |
//|                                         http://www.nolinkyet.net |
//+------------------------------------------------------------------+

// Uses the 'trend' buffer number from each indicator in start below.

// todo:
//    add All_TrendEnvelopes_v3.mq4 and TurboTrendStrength.mq4
//    they use the 'trend' buffer number too.

#property copyright "Copyright  2008, NonDisclosure007"
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_minimum -12
#property indicator_maximum 12
#property indicator_color1 Blue
/*
#property indicator_level1 5
#property indicator_level2 -5
#property indicator_level3 3
#property indicator_level4 -3
#property indicator_level5 0
*/

double Buffer[];
bool varWriteFile = false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Buffer);
   SetIndexLabel(0,"TrendLabs");
   return(0);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted(); int limit; 
   if(counted_bars<0) return(-1); 
      
   limit=Bars-counted_bars-1;
   if (varWriteFile==true)
   {
      int handle;
      handle=FileOpen("trendlabs.csv",FILE_CSV|FILE_READ|FILE_WRITE,',');
      FileWrite(handle,"ABS","AddSignal","TrendEnvelopes","TrendStrength","LabTrend1","LabTrend2","LabTrend3","VoltyChannel_Stop","TrendRSI","All_TrendEnvelopes_v3","TurboTrendStrength");
   }
   
   for(int shift=0; shift<limit; shift++)
   {
      Buffer[shift]=
      funcGetAbsoluteStrength(shift)+
      iCustom(NULL,0,"AddSignal_v1.1",2,shift)+
      iCustom(NULL,0,"TrendEnvelopes_v2",6,shift)+
      iCustom(NULL,0,"TrendStrength_v2",7,shift)+
      iCustom(NULL,0,"LabTrend1_v4",7,shift)+
      iCustom(NULL,0,"LabTrend2_v2",4,shift)+
      iCustom(NULL,0,"LabTrend3_v2",6,shift)+
      iCustom(NULL,0,"VoltyChannel_Stop_v2.1",6,shift)+
      iCustom(NULL,0,"TrendRSI_v3",6,shift)+
      iCustom(NULL,0,"All_TrendEnvelopes_v3",6,shift)+
      iCustom(NULL,0,"TurboTrendStrength",7,shift);
      if (varWriteFile==true)
      {
         FileWrite(handle,funcGetAbsoluteStrength(shift),
                       iCustom(NULL,0,"AddSignal_v1.1",2,shift),
                       iCustom(NULL,0,"TrendEnvelopes_v2",6,shift),
                       iCustom(NULL,0,"TrendStrength_v2",7,shift),
                       iCustom(NULL,0,"LabTrend1_v4",7,shift),
                       iCustom(NULL,0,"LabTrend2_v2",4,shift),
                       iCustom(NULL,0,"LabTrend3_v2",6,shift),
                       iCustom(NULL,0,"VoltyChannel_Stop_v2.1",6,shift),
                       iCustom(NULL,0,"TrendRSI_v3",6,shift),
                       iCustom(NULL,0,"All_TrendEnvelopes_v3",6,shift),
                       iCustom(NULL,0,"TurboTrendStrength",7,shift));
       }                    
   }
   FileClose(handle);   
   return(0);
  }

double funcGetAbsoluteStrength(int shift)
{
   double varBulls=iCustom(NULL,0,"AbsoluteStrength_v1.1",0,shift);
   double varBears=iCustom(NULL,0,"AbsoluteStrength_v1.1",1,shift);
   double varSignalBulls=iCustom(NULL,0,"AbsoluteStrength_v1.1",2,shift);
   double varSignalBears=iCustom(NULL,0,"AbsoluteStrength_v1.1",3,shift);
   if (varBulls>varSignalBulls && varBulls>varBears) return(1);
   if (varBears>varSignalBears && varBears>varBulls) return(-1);
   return(0);
}